(* EPITA SPE 2009/2010       *)
(* Partiel 1 - Décembre 2009 *)
(* question 08               *)

module type S =
sig
  type t
  val zero      : t
  val succ      : t -> t
  val pred      : t -> t
  val add       : t -> t -> t
  val canon     : t -> t
  val equal     : t -> t -> bool
  val to_string : t -> string
end

module Peano : S =
struct
  type t = Zero | Succ of t | Pred of t
  let zero = Zero
  let succ i = Succ i
  let pred i = Pred i
  let rec add i = function
      Zero -> i
    | Succ j -> add (Succ i) j
    | Pred j -> add (Pred i) j

  let rec twoset = function
      Zero -> ([],[])
    | Pred x ->
	let (p,s) = twoset x in
	  (1::p,s)
    | Succ x ->
	let (p,s) = twoset x in
	  (p,1::s)

  let rec twoset2peano = function
      (_::p,_::s) -> twoset2peano (p,s)
    | ([],[]) -> zero
    | ([],_::s) -> Succ (twoset2peano ([],s))
    | (_::p,[]) -> Pred (twoset2peano (p,[]))

  let rec canon = function
      Zero -> Zero
    | x -> twoset2peano (twoset x)

  let equal x y =
    (canon x) = (canon y)

  let rec to_string = function
      Zero -> "0"
    | Succ n -> "Succ(" ^ (to_string n) ^ ")"
    | Pred n -> "Pred(" ^ (to_string n) ^ ")"
end
