(* EPITA SPE 2009/2010       *)
(* Partiel 1 - Décembre 2009 *)
(* question 09               *)

module type OrderedType =
sig
  type t
  val compare   : t -> t -> int
  val to_string : t -> string
end

module type S =
sig
  type elm
  type t
  val compare   : t -> t -> int
  val make      : elm -> elm -> t
  val to_string : t -> string
end

module ComparablePair (T:OrderedType) =
struct

  type elm = T.t
  type t = elm * elm

  let compare (a,b) (c,d) =
    let r = T.compare a c in
      if r = 0 then T.compare b d
      else r

  let make a b = (a,b)
  let to_string (x,y) =
     Printf.sprintf "(%s,%s)" (T.to_string x) (T.to_string y)
end

