module type OrderedType =
  sig type t val compare : t -> t -> int val to_string : t -> string end
module type S =
  sig
    type elm
    type t
    val compare : t -> t -> int
    val make : elm -> elm -> t
    val to_string : t -> string
  end
module ComparablePair :
  functor (T : OrderedType) -> S with type elm = T.t
