(* EPITA SPE 2009/2010       *)
(* Partiel 1 - Décembre 2009 *)
(* question 10               *)

exception Vector_full

class virtual ['a] iterable =
object (s)
  method virtual next  : 'a option
  method virtual reset : unit
  method iter (f: 'a -> unit) =
    match s#next with
	None -> ()
      | Some x -> f x ; s#iter f
end

class ['a] iterable_vector max a =
object (s)

  inherit ['a] iterable

  val mutable size = 0
  val mutable curr = -1
  val vect : 'a array = Array.make max a

  method add x =
    if size < max then
      begin
	vect.(size) <- x;
	size <- size + 1
      end
    else raise Vector_full

  method next =
    curr <- curr + 1;
    if (curr < size) then
      Some (vect.(curr))
    else
      None

  method reset = curr <- -1

end
