(* EPITA SPE 2009/2010       *)
(* Partiel 1 - Décembre 2009 *)
(* question 09 - test        *)

module Q = Question09

module NCStr =
struct
  type t = string
  let compare a b =
    compare (String.lowercase a) (String.lowercase b)
  let to_string x = x
end

module NCStrPair = Q.ComparablePair(NCStr)
module NCStrQuad = Q.ComparablePair(NCStrPair)
module StrQuadSet = Set.Make(NCStrQuad)

let make q =
  NCStrQuad.make
    (NCStrPair.make q#makeString q#makeString)
    (NCStrPair.make q#makeString q#makeString)

let rec nfold f a = function
    0 -> a
  | n -> nfold f (f a) (n-1)

let main () =
  begin
    let q = new Test_frame.qSizeString 9 1 in
      q#beginParse;
      q#init;
      let s =
	nfold (fun x -> StrQuadSet.add (make q) x) StrQuadSet.empty q#getSize
      in
	Format.printf "{@[<v 2>";
	StrQuadSet.iter
	  (fun x -> Format.printf "@;%s;" (NCStrQuad.to_string x)) s;
	Format.printf "@]@;}@.";
  end

let _ = main ()
